package com.ints.bieshop.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class ProductOptionAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductOptionAllPropertiesEquals(ProductOption expected, ProductOption actual) {
        assertProductOptionAutoGeneratedPropertiesEquals(expected, actual);
        assertProductOptionAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductOptionAllUpdatablePropertiesEquals(ProductOption expected, ProductOption actual) {
        assertProductOptionUpdatableFieldsEquals(expected, actual);
        assertProductOptionUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductOptionAutoGeneratedPropertiesEquals(ProductOption expected, ProductOption actual) {
        assertThat(expected)
            .as("Verify ProductOption auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductOptionUpdatableFieldsEquals(ProductOption expected, ProductOption actual) {
        assertThat(expected)
            .as("Verify ProductOption relevant properties")
            .satisfies(e -> assertThat(e.getName()).as("check name").isEqualTo(actual.getName()))
            .satisfies(e -> assertThat(e.getPriceModifier()).as("check priceModifier").isEqualTo(actual.getPriceModifier()))
            .satisfies(e -> assertThat(e.getUnit()).as("check unit").isEqualTo(actual.getUnit()))
            .satisfies(e -> assertThat(e.getIsDeleted()).as("check isDeleted").isEqualTo(actual.getIsDeleted()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertProductOptionUpdatableRelationshipsEquals(ProductOption expected, ProductOption actual) {
        assertThat(expected)
            .as("Verify ProductOption relationships")
            .satisfies(e -> assertThat(e.getProduct()).as("check product").isEqualTo(actual.getProduct()));
    }
}
